package betterwithmods.module.hardcore.needs;

import betterwithmods.module.Feature;
import betterwithmods.module.ModuleLoader;
import betterwithmods.util.item.StackMap;
import betterwithmods.util.player.PlayerHelper;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraftforge.event.entity.living.LivingEvent;
import net.minecraftforge.fml.common.event.FMLInitializationEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.oredict.OreDictionary;

/**
 * Created by tyler on 5/10/17.
 */
public class HCArmor extends Feature {
    public static final StackMap<Integer> weights = new StackMap<>(0);

    public static void initWeights() {
        weights.put(Items.field_151020_U, OreDictionary.WILDCARD_VALUE, 3);
        weights.put(Items.field_151023_V, OreDictionary.WILDCARD_VALUE, 4);
        weights.put(Items.field_151022_W, OreDictionary.WILDCARD_VALUE, 4);
        weights.put(Items.field_151029_X, OreDictionary.WILDCARD_VALUE, 2);

        weights.put(Items.field_151028_Y, OreDictionary.WILDCARD_VALUE, 5);
        weights.put(Items.field_151030_Z, OreDictionary.WILDCARD_VALUE, 8);
        weights.put(Items.field_151165_aa, OreDictionary.WILDCARD_VALUE, 7);
        weights.put(Items.field_151167_ab, OreDictionary.WILDCARD_VALUE, 4);

        weights.put(Items.field_151161_ac, OreDictionary.WILDCARD_VALUE, 5);
        weights.put(Items.field_151163_ad, OreDictionary.WILDCARD_VALUE, 8);
        weights.put(Items.field_151173_ae, OreDictionary.WILDCARD_VALUE, 7);
        weights.put(Items.field_151175_af, OreDictionary.WILDCARD_VALUE, 4);

        weights.put(Items.field_151169_ag, OreDictionary.WILDCARD_VALUE, 5);
        weights.put(Items.field_151171_ah, OreDictionary.WILDCARD_VALUE, 8);
        weights.put(Items.field_151149_ai, OreDictionary.WILDCARD_VALUE, 7);
        weights.put(Items.field_151151_aj, OreDictionary.WILDCARD_VALUE, 4);
    }

    public static float getWeight(ItemStack stack) {
        if(!ModuleLoader.isFeatureEnabled(HCArmor.class))
            return 0;
        return weights.get(stack);
    }

    @Override
    public String getFeatureDescription() {
        return "Gives Armor weight values that effect movement.";
    }

    @Override
    public void init(FMLInitializationEvent event) {
        initWeights();
    }

    @SubscribeEvent
    public void swimmingPenalty(LivingEvent.LivingUpdateEvent event) {
        if (!(event.getEntityLiving() instanceof EntityPlayer))
            return;
        EntityPlayer player = (EntityPlayer) event.getEntityLiving();
        if (PlayerHelper.isSurvival(player) && player.func_70090_H() && !PlayerHelper.canSwim(player) && !PlayerHelper.isNearBottom(player)) {
            player.field_70181_x -= 0.02;
        }
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }
}
