package betterwithmods.module.tweaks;

import betterwithmods.module.Feature;
import net.minecraft.block.BlockStoneBrick;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.tileentity.TileEntityMobSpawner;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;
import net.minecraftforge.fml.relauncher.Side;

import java.util.ConcurrentModificationException;
import java.util.List;
import java.util.Random;
import java.util.stream.Collectors;

/**
 * Created by tyler on 4/20/17.
 */
public class MossGeneration extends Feature {

    @SubscribeEvent
    public void generateMossNearSpawner(TickEvent.WorldTickEvent event) {
        if (event.world.field_72995_K || event.phase != TickEvent.Phase.END || event.side != Side.SERVER)
            return;
        Random rand = event.world.field_73012_v;
        List<BlockPos> positions = event.world.field_147482_g.stream().filter(t -> t instanceof TileEntityMobSpawner).map(TileEntity::func_174877_v).collect(Collectors.toList());
        try {
            positions.forEach(pos -> {
                int x = rand.nextInt(9) - 4;
                int y = rand.nextInt(5) - 1;
                int z = rand.nextInt(9) - 4;
                BlockPos check = pos.func_177982_a(x, y, z);
                IBlockState state = event.world.func_180495_p(check);
                if ((state.func_177230_c() == Blocks.field_150347_e || (state.func_177230_c() == Blocks.field_150417_aV && state.func_177230_c().func_176201_c(state) == 0)) && rand.nextInt(30) == 0) {
                    IBlockState changeState = state.func_177230_c() == Blocks.field_150347_e ? Blocks.field_150341_Y.func_176223_P() : Blocks.field_150417_aV.func_176223_P().func_177226_a(BlockStoneBrick.field_176249_a, BlockStoneBrick.EnumType.MOSSY);
                    event.world.func_175656_a(check, changeState);
                }
            });
        } catch (ConcurrentModificationException ignored) {
        }
    }

    @Override
    public boolean hasSubscriptions() {
        return true;
    }

    @Override
    public String getFeatureDescription() {
        return "Cobblestone or Stonebrick within the spawning radius of a Mob Spawner will randomly grow into the Mossy version.";
    }
}
